﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Media;
using System.Windows.Shapes;
using System.Windows.Controls;
using Microsoft.Research.Kinect.Nui;
using Coding4Fun.Kinect.Wpf;

namespace SkeletalTracking
{
    class CustomController1 : SkeletonController
    {
        public CustomController1(MainWindow win) : base(win){}

        private bool targetSelected = false;

        public override void processSkeletonFrame(SkeletonData skeleton, Dictionary<int, Target> targets)
        {

            /*Example implementation*/
            foreach (var target in targets)
            {
                Target cur = target.Value;
                int targetID = cur.id; //ID in range [1..5]

                //Scale the joints to the size of the window
                Joint leftHand = skeleton.Joints[JointID.HandLeft].ScaleTo(640, 480, window.k_xMaxJointScale, window.k_yMaxJointScale);
                Joint rightHand = skeleton.Joints[JointID.HandRight].ScaleTo(640, 480, window.k_xMaxJointScale, window.k_yMaxJointScale);

                //Calculate how far our left hand is from the target in both x and y directions
                double deltaX_left = Math.Abs(leftHand.Position.X - cur.getXPosition());
                double deltaY_left = Math.Abs(leftHand.Position.Y - cur.getYPosition());

                //Calculate how far our right hand is from the target in both x and y directions
                double deltaX_right = Math.Abs(rightHand.Position.X - cur.getXPosition());
                double deltaY_right = Math.Abs(rightHand.Position.Y - cur.getYPosition());

                    //If we have a hit in a reasonable range, highlight the target
                    if (deltaX_left < 45 && deltaY_left < 45 && deltaX_right < 45 && deltaY_right < 45)
                    {
                        if (targetSelected == false)
                        {
                            cur.setTargetSelected();
                            double average_x = ((rightHand.Position.X + leftHand.Position.X) / 2) - 75 / 2;
                            double average_y = ((rightHand.Position.Y + leftHand.Position.Y) / 2) - 75 / 2;
                            cur.setTargetPosition(average_x, average_y);
                            targetSelected = true;
                        }
                    }
                    else
                    {
                        targetSelected = false;
                    }

                    double like_x = Math.Abs(122 - cur.getXPosition());
                    double like_y = Math.Abs(365 - cur.getYPosition());

                    if (like_x < 65 && like_y < 65)
                    {
                        cur.setTargetLiked();
                    }

                    double dislike_x = Math.Abs(484 - cur.getXPosition());
                    double dislike_y = Math.Abs(365 - cur.getYPosition());

                    if (dislike_x < 65 && dislike_y < 65)
                    {
                        cur.setTargetDisliked();
                    }
            }

        }

        public override void controllerActivated(Dictionary<int, Target> targets)
        {
            foreach (var target in targets)
            {
                Target cur = target.Value;
                cur.setTargetInitial();
               
            }

        }
    }
}
